/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// Base(XMS_B) 画面ソート処理クラス
//			変更履歴
//				2004.01.08	新規作成	二條智文
//
package jp.co.ntt.lms.xmo.Base.Gui;

import java.text.Collator;
import java.util.Vector;

/**
 * Base(XMS_B) 画面表示データ保持クラスです。<BR>
 * @author T.Nijou
 * @version 0.0.0.1 2004/01/08
 */
public class BaseSort {

	// ソートフィールド
	/** 名前でソート */
	public static final int NAME_FIELD = 0;
	/** コメントでソート */
	public static final int COMMENT_FIELD = 1;

	// ソートタイプ
	/** 昇順でソート */
	public static final int UP_TYPE = 0;
	/** 降順でソート */
	public static final int DOWN_TYPE = 1;

	/** ソートフィールドを保持します */
	private int mintSortField;
	/** ソートタイプを保持します */
	private int mintSortType;


	/**
	 * コンストラクタです。<BR>
	 * ソートするフィールドと降順、昇順ソートを指定してください。
	 * @param objBaseDisplayList ソート対象画面オブジェクトリスト
	 * @param intSortField ソートフィールド指定
	 * <P>
	 *        NAME_FIELD: 名前でソート
	 *        COMMENTFIELD: コメントでソート
	 * </P>
	 * @param intType ソートタイプ指定
	 * <P>
	 *        UP_TYPE: 昇順でソート
	 *        DOWN_TYPE: 降順でソート
	 * </P>
	 * @exception XMOException パラメータエラー
	 */
	public BaseSort( int intSortField, int intSortType )
		throws BaseGuiException
	{
		if( intSortField != NAME_FIELD &&
			intSortField != COMMENT_FIELD ) {
			throw new BaseGuiException( "ソートフィールド指定が不正です。" );
		}
		if( intSortType != UP_TYPE &&
			intSortType != DOWN_TYPE ) {
			throw new BaseGuiException( "ソートタイプ指定が不正です。" );
		}

		mintSortField = intSortField;
		mintSortType = intSortType;

	}

	/**
	 * ソート処理を行います
	 * @return BaseDisplayList[] ソート済みDisplayオブジェクト
	 * @exception XMOException パラメータエラー
	 */
	public BaseDisplayData[] sort(BaseDisplayData[] objBaseDisplayList )
		throws BaseGuiException
	{

		// パラメータチェック
		if( objBaseDisplayList == null ) {
			throw new BaseGuiException( "画面オブジェクトがnullです" );
		}

		// 文字コード比較用
		Collator collator = Collator.getInstance();
		collator.setDecomposition(Collator.FULL_DECOMPOSITION);
		// ソート文字列を格納します
		Vector vecSortString = new Vector();
		// ソート済みオブジェクトを格納します
		Vector vecSort = new Vector();

		for( int i = 0; i < objBaseDisplayList.length; i++ ) {
			BaseDisplayData objDisplay = objBaseDisplayList[i];

			String strSortString = "";
			if( mintSortField == NAME_FIELD ) {
				strSortString = objDisplay.getTitle();
			}
			else {
				strSortString = objDisplay.getDescription();
			}

			// ソートリストが空の場合
			if( vecSortString.size() == 0 ) {
				//リストの最後に追加する。
				vecSortString.add(strSortString);
				vecSort.add(objDisplay);
			}
			//ソートリストにﾃﾞｰﾀが存在したら
			else {

				boolean blFlag = false;
				for( int j = 0; j < vecSortString.size(); j++ ) {
					//昇順指定ならば
					if(mintSortType == 0) {
						//リスト内に保持しているソート名より文字コードが小さければ
						if( collator.compare( strSortString, (String)vecSortString.get(j) ) < 0) {
							//現在の位置にソート名､HTML文字列を格納する。
							vecSortString.add(j, strSortString);
							vecSort.add(j, objDisplay);
							//最終判定ﾌﾗｸﾞをTRUEに設定
							blFlag = true;
							break;
						}
					}
					//降順指定ならば
					else
					{
						//リスト内に保持しているソート名より文字コードが大きければ
						if( collator.compare( strSortString, (String)vecSortString.get(j) ) > 0)
						{
							//現在の位置にソート名､HTML文字列を格納する。
							vecSortString.add(j, strSortString);
							vecSort.add(j, objDisplay);
							//最終判定ﾌﾗｸﾞをTRUEに設定
							blFlag = true;
							break;
						}
					}
				}
				//ソート名リスト全てと比較した結果、リストにまだ追加していなかったら
				if( !blFlag )
				{
					//リストの最後に追加する。
					vecSortString.add(strSortString);
					vecSort.add(objDisplay);
				}
			}
		}

		// Vectorの中身をコピーする
		BaseDisplayData[] objDisplaySortList = new BaseDisplayData[vecSort.size()];
		vecSort.copyInto(objDisplaySortList);

		return objDisplaySortList;
	}

}
